/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//機能名称 
//			 CMI データモデル　ノードクラス
//	変更履歴
//				2004.02.13	A.Kudoh  新規作成
//
package jp.co.ntt.lms.lo.scorm.cbtcom;

import java.util.NoSuchElementException;

/**
 * CMI データモデル　トークン切り出しクラス
 * @author A.Kudoh
 */
public class CMITokenizer extends Object {

	/**
	 * 指定文字列
	 */
	private String m_str;

	/**
	 * 文字トークンの現在位置
	 */
	private int m_curIndex = 0;

	/**
	 * デリミタ文字
	 */
	private String m_delimiter;

	/**
	 * 次トークンの存在フラグ
	 */
	boolean m_hasMore = false;

	/**
     * トークン切り出しクラス。<br>
     * @param str String 解析される文字列
     * @param delimiter String 区切り文字
     */
	public CMITokenizer(String str, String delimiter) {
		m_str = str;
		m_curIndex = 0;
		m_hasMore = true;
		m_delimiter = delimiter;
	}

	/**
     * 文字列トークナイザから次のトークンを返す。<br>
     * @exception NoSuchElementException トークナイザから文字列が取り出せない場合
     */
	public String nextToken() throws NoSuchElementException {

		String token = "";

		if (m_delimiter.length() == 0) {
			String msg = "Tokenizer::getNext: delimiter not set";
			NoSuchElementException ex = new NoSuchElementException(msg);
			throw ex;
		}

		if (m_curIndex == -1) {
			token = "";
		} else {
			int iNextPos = m_str.indexOf(m_delimiter, m_curIndex);
			if (iNextPos == -1) {
				token = m_str.substring(m_curIndex);
				m_curIndex = -1;
				m_hasMore = false;
			} else {
				token = m_str.substring(m_curIndex, iNextPos);
				m_curIndex = iNextPos + m_delimiter.length();
			}
		}
		return token;
	}

	/**
	 * トークナイザの文字列で利用できるトークンがまだあるかどうかを
	 * 判定する。<br>
	 * @return boolean 次トークン有り（true）、次トークンなし（false）
	 */
	public boolean hasMoreTokens() {
		return m_hasMore;
	}

	/**
	 * トークナイザの文字列で利用できる文字列を返す。<br>
	 * @return String まだトークン切り出しができる文字列
	 */
	public String getRest() {
		return m_str.substring(m_curIndex);
	}
}

